﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	Private frontCamera As Boolean = False
End Sub

Sub Globals
	Private Panel1 As Panel
	Private camEx As CameraExClass
	
	Dim filename As String
	Dim dir As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("1")
End Sub

Sub Activity_Resume
	InitializeCamera
End Sub

Private Sub InitializeCamera
	camEx.Initialize(Panel1, frontCamera, Me, "Camera1")
	frontCamera = camEx.Front
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	camEx.Release
End Sub

Sub Camera1_Ready (Success As Boolean)
	If Success Then
		camEx.SetJpegQuality(20)				'90
		camEx.CommitParameters
		camEx.StartPreview
		Log(camEx.GetPreviewSize)
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
End Sub

Sub btnTakePicture_Click
	camEx.TakePicture
End Sub

Sub btnFocus_Click
	camEx.FocusAndTakePicture
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	filename = Main.pictext & ".png"
	Log(filename)
	dir = File.DirDefaultExternal
	Log(dir)
	camEx.SavePictureToFile(Data, dir, filename)
	camEx.StartPreview 'restart preview
	
	
	'send a broadcast intent to the media scanner to force it to scan the saved file.
	Dim Phone As Phone
	Dim i As Intent
	i.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
		"file://" & File.Combine(dir, filename))
	Phone.SendBroadcastIntent(i)
	ToastMessageShow("Picture saved." & CRLF  & "File size: " & File.Size(dir, filename), True)
	InsertBlob(Main.pictext)
End Sub

Sub ChangeCamera_Click
	camEx.Release
	frontCamera = Not(frontCamera)
	InitializeCamera
End Sub

Sub btnEffect_Click
	Dim effects As List = camEx.GetSupportedColorEffects
	If effects.IsInitialized = False Then
		ToastMessageShow("Effects not supported.", False)
		Return
	End If
	Dim effect As String = effects.Get((effects.IndexOf(camEx.GetColorEffect) + 1) Mod effects.Size)
	camEx.SetColorEffect(effect)
	ToastMessageShow(effect, False)
	camEx.CommitParameters
End Sub

Sub btnFlash_Click
	Dim f() As Float = camEx.GetFocusDistances
	Log(f(0) & ", " & f(1) & ", " & f(2))
	Dim flashModes As List = camEx.GetSupportedFlashModes
	If flashModes.IsInitialized = False Then
		ToastMessageShow("Flash not supported.", False)
		Return
	End If
	Dim flash As String = flashModes.Get((flashModes.IndexOf(camEx.GetFlashMode) + 1) Mod flashModes.Size)
	camEx.SetFlashMode(flash)
	ToastMessageShow(flash, False)
	camEx.CommitParameters	
End Sub
Sub btnPictureSize_Click
	Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes
	Dim current As CameraSize = camEx.GetPictureSize
	For i = 0 To pictureSizes.Length - 1
		If pictureSizes(i).Width = current.Width AND pictureSizes(i).Height = current.Height Then Exit
	Next
	Dim ps As CameraSize = pictureSizes((i + 1) Mod pictureSizes.Length)
	camEx.SetPictureSize(ps.Width, ps.Height)
	ToastMessageShow(ps.Width & "x" & ps.Height, False)
	camEx.CommitParameters		
End Sub

Sub InsertBlob(pict As String)
	'convert the image file to a bytes array
	Dim InputStream1 As InputStream
	InputStream1 = File.OpenInput(File.DirDefaultExternal, filename)
	Dim OutputStream1 As OutputStream
	OutputStream1.InitializeToBytesArray(1000)
	File.Copy2(InputStream1, OutputStream1)
	Dim Buffer() As Byte
	Buffer = OutputStream1.ToBytesArray
	
	'write the image to the database
	Main.sql1.ExecNonQuery2("INSERT INTO Inv VALUES(?, ?)", Array As Object(pict, Buffer))
End Sub